/**************************************************************************************************/

/*
* File: main.c
* Author: ECE 275 Spring 2016
* NetID:
* Date: Feb 2, 2016
*
* Description:  
*
*/

/**************************************************************************************************/
 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

/**************************************************************************************************/

/*
 * Initializes array values with values 0, 1, ...
 *
 * arrayVals: pointer to an array of integers.
 * numElements: number of elements within the arrayVals array
 *
 */
void InitializeArray(int* arrayVals, int numElements) {
   int i = 0;
   
   for(i = 0; i < numElements; ++i) {
      arrayVals[i] = i;
   }
}

/**************************************************************************************************/

/*
 * Prints array contents on a single line with a space between each element.
 *
 * arrayVals: pointer to an array of integers.
 * numElements: number of elements within the arrayVals array
 *
 */
void PrintArray(int* arrayVals, int numElements) {
   int i = 0;
   
   for(i = 0; i < numElements; ++i) {
      printf("%d ", arrayVals[i]);
   }
   printf("\n");
}

/**************************************************************************************************/

int main(int argc, char* argv[]) {
   int *integerArray = NULL;
   int numIntegers = 0;
   int i = 0;
   int intergerToInsert = 100;
   int posToInsert = 2;
	
	if (argc != 2) {
		printf("Usage statement: this program takes an integer array size as input\n");
		return 0;
	}
	else {
      // Convert command line argument to integer
		sscanf(argv[1], "%d", &numIntegers);
      
      // Allocate the array using the user specified size.
		integerArray = (int *)malloc(sizeof(int) * numIntegers);
      
      // Check to ensure the array was allcoated correctly. If malloc() failed,
      // prints a descriptive error messages and exits.
		if (integerArray == NULL) {
			printf("Unable to allocate memory.\n");
			return EXIT_FAILURE;
		}
	}

   InitializeArray(integerArray, numIntegers);
   printf("Initial array: ");
   PrintArray(integerArray, numIntegers);
   
   // To insert a new elements within the array, we need to follow the following steps
   //
   // 1. Reallocate the array to increase the size by one elements.
   // 2. Check to ensure realloc() succeeded
   // 3. Starting at end of the array, move all array elements one position forward
   //    until the insert positions is reached.
   // 4. Insert the new element at specified position
   // 5. Increment variable storing array size
   
   // 1. Reallocate the array to increase the size by one elements.
   integerArray = (int *)realloc(integerArray, sizeof(int) * (numIntegers + 1));
   
   // 2. Check to ensure realloc() succeeded
   if( integerArray == NULL ) {
      printf("Unable to allocate memory.\n");
      return EXIT_FAILURE;
   }
   
   // 3. Starting at end of the array, move all array elements one position forward
   //    until the insert positions is reached.
   for (i = numIntegers; i > posToInsert; i--) {
      integerArray[i] = integerArray[i - 1];
   }
   
   // 4. Insert the new element at specified position
   integerArray[posToInsert] = intergerToInsert;
	
   // 5. Increment variable storing array size
   numIntegers++;

   printf("Array after inserting %d at index %d: ", intergerToInsert, posToInsert);
   PrintArray(integerArray, numIntegers);

   // All dyanmcaily allcoate demmroy should be freed when that memory is not longer needed.
	free(integerArray);
 
	return 0;
}

/**************************************************************************************************/
